<template>
  <Filters
    :report-button="true"
    @reset-form="data = []"
    @run-search="() => filterData(filters)"
    class="mb-4"
  >
    <Type2 @update:filters="(value) => (filters = value)" />
  </Filters>

  <div id="data">
    <DxDataGrid
      class="max-h-[calc(100vh-140px)] mb-10"
      :data-source="data"
      :show-column-lines="true"
      :show-row-lines="false"
      :show-borders="true"
      :row-alternation-enabled="true"
      :hover-state-enabled="true"
      @selection-changed="onSelectionChanged"
      @exporting="onExporting"
      :allow-column-resizing="true"
      column-resizing-mode="widget"
      :word-wrap-enabled="true"
    >
      <DxSelection mode="single" />
      <DxPaging :enabled="false" />
      <DxScrolling column-rendering-mode="virtual" mode="virtual" />
      <DxLoadPanel
        :position="position"
        :show-indicator="showIndicator"
        :show-pane="showPane"
        :shading="shading"
        v-if="loading"
        v-model:visible="loading"
        :enabled="true"
      />
      <DxSearchPanel :visible="true" :highlight-case-sensitive="true" />
      <DxExport
        :enabled="true"
        :formats="['pdf', 'xlsx', 'document']"
        :allow-export-selected-data="false"
      />
      <DxColumnFixing :enabled="true" />

      <DxColumn
        :min-width="250"
        alignment="center"
        data-field="nama_ulp"
        caption="Nama Unit"
        css-class="custom-table-column"
        cell-template="formatText"
      />
      <DxColumn
        alignment="center"
        caption="Kepatuhan dan Akurasi APKT"
        css-class="custom-table-column"
      >
        <DxColumn alignment="center" caption="Gangguan Berulang" css-class="custom-table-column">
          <DxColumn
            :width="150"
            alignment="center"
            data-field="gangguan_berulang"
            data-type="number"
            caption="Jan 2020"
            css-class="custom-table-column"
          />
          <DxColumn
            :width="150"
            alignment="center"
            data-field="gangguan_total"
            data-type="number"
            caption="Total Gangguan"
            css-class="custom-table-column"
          />
        </DxColumn>
        <DxColumn alignment="center" caption="Keluhan Berulang" css-class="custom-table-column">
          <DxColumn
            :width="150"
            alignment="center"
            data-field="komplain_pelanggan"
            data-type="number"
            caption="Jan 2020"
            css-class="custom-table-column"
          />
          <DxColumn
            :width="150"
            alignment="center"
            data-field="keluhan_total"
            data-type="number"
            caption="Total Keluhan"
            css-class="custom-table-column"
          />
        </DxColumn>
      </DxColumn>
      <DxColumn
        :min-width="150"
        alignment="center"
        data-field="komplain_pelanggan"
        data-type="number"
        caption="Komplain Pelanggan %"
        css-class="custom-table-column"
        cell-template="percent"
      />

      <template #percent="{ data }">
        <p>{{ data.text }}%</p>
      </template>

      <template #formatText="{ data }">
        <p class="text-left">
          {{ data.text }}
        </p>
      </template>
    </DxDataGrid>
  </div>
</template>

<script setup lang="ts">
import { ref } from 'vue'
import Filters from '@/components/Form/Filters.vue'
import Type2 from '@/components/Form/FiltersType/Type2.vue'
import { DxDataGrid } from 'devextreme-vue'
import {
  DxColumn,
  DxColumnFixing,
  DxExport,
  DxLoadPanel,
  DxPaging,
  DxScrolling,
  DxSearchPanel,
  DxSelection
} from 'devextreme-vue/data-grid'
import { jsPDF } from 'jspdf'
import { exportDataGrid as exportToPdf } from 'devextreme/pdf_exporter'
import { exportDataGrid as exportToExcel } from 'devextreme/excel_exporter'
import { saveAs } from 'file-saver'
import { Workbook } from 'exceljs'
import { useQuery } from '@vue/apollo-composable'
import { queries } from '@/utils/api/api.graphql'

const position = { of: '#data' }
const showIndicator = ref(true)
const shading = ref(true)
const showPane = ref(true)
const data = ref<any[]>([])
const currentYear = ref(new Date().getFullYear())
const currentMonth = ref(new Date().getMonth())
const lastYear = ref(currentYear.value - 1)

const onExporting = (e: any) => {
  if (e.format === 'pdf') {
    const doc = new jsPDF()

    exportToPdf({
      jsPDFDocument: doc,
      component: e.component,
      indent: 5
    }).then(() => {
      doc.save(`.pdf`)
    })
  } else {
    const workbook = new Workbook()
    const worksheet = workbook.addWorksheet('Employees')

    exportToExcel({
      component: e.component,
      worksheet,
      autoFilterEnabled: true
    }).then(() => {
      workbook.xlsx.writeBuffer().then((buffer: any) => {
        saveAs(new Blob([buffer], { type: 'application/octet-stream' }), 'DataGrid.xlsx')
      })
    })

    e.cancel = true
  }
}

const onSelectionChanged = ({ selectedRowsData }: any) => {
  const data = selectedRowsData[0]
  console.log(data)
}

const { onResult, onError, loading, refetch } = useQuery(
  queries.monalisa.laporan.bulanan.kepatuhandanAkurasiDalamPelaporanBulanan,
  {
    // regional: 0,
    idUp3: 0,
    idUid: 0,
    idUlp: 0,
    bulan: currentMonth.value,
    tahun: currentYear.value
  }
)

const filterData = (params: any) => {
  const { regional, ulp, uid, up3, bulan, tahun } = params
  currentMonth.value = bulan.id
  currentYear.value = tahun.id
  lastYear.value = tahun.id - 1
  refetch({
    // regional: regional,
    idUid: uid ? uid.id : 0,
    idUp3: up3 ? up3.id : 0,
    idUlp: ulp ? ulp.id : 0,
    bulan: bulan ? bulan.id : currentMonth.value,
    tahun: bulan ? tahun.id : currentYear.value
  })
  onResult((queryResult) => {
    if (queryResult.data != undefined) {
      queryResult.data.kepatuhandanAkurasiDalamPelaporanBulanan.forEach((item: any) => {
        data.value = [
          ...data.value,
          {
            ...item
          }
        ]
      })
    }
    console.log(queryResult.data)
    console.log(queryResult.loading)
    console.log(queryResult.networkStatus)
  })
  onError((error) => {
    console.log(error)
  })
}
const filters = ref()
</script>
